// API hook
//
// GetProcAddressœcalli֐{́j𒼐ڏA
// ̃tbN֐jmpB
//
// ŌAPIǵAR[hx߂ĂcallB
// jmpR[hɖ߂B
//
// }`Xbh callƍ̂ŁA
// CriticalSectionŔr䂵ĂB
//
#include "override.h"
#include "ft.h"
#include "fteng.h"
#include <locale.h>

typedef struct {
	void*	addr;
	BYTE	hook [1 + sizeof(void*)];
	BYTE	orig [1 + sizeof(void*)];
	CRITICAL_SECTION lock;
} HookData;

static BOOL __fastcall _hook_init(FARPROC func, HookData* p, FARPROC hook)
{
	p->addr = NULL;

	DWORD old;
	if(!VirtualProtect(func, sizeof(p->orig), PAGE_EXECUTE_READWRITE, &old)) {
		return FALSE;
	}

	p->addr = (void*) func;

	// init
	InitializeCriticalSection(&p->lock);

	// save original
	memcpy(p->orig, p->addr, sizeof(p->orig));
//	FlushInstructionCache((HANDLE)-1, p->addr, sizeof(p->orig));

	// hook code
	char* offset = (char*)((char*)hook - (char*)p->addr - sizeof(p->hook));
	p->hook[0] = 0xE9;//jmp
	memcpy(p->hook+1, &offset, sizeof(offset));
	FlushInstructionCache((HANDLE)-1, p->hook, sizeof(offset)+1);

	// install : DllMain͑XbhCɂȂėǂ͂
	// ccȂȂ
	memcpy(p->addr, p->hook, sizeof(p->hook));
	FlushInstructionCache((HANDLE)-1, p->addr, sizeof(p->hook));
	return TRUE;
}


static void __fastcall _hook_term(HookData* p)
{
	if(p->addr) {
		EnterCriticalSection(&p->lock);
		memcpy(p->addr, p->orig, sizeof(p->orig));
		FlushInstructionCache((HANDLE)-1, p->addr, sizeof(p->orig));
		LeaveCriticalSection(&p->lock);
		DeleteCriticalSection(&p->lock);
		p->addr = NULL;
	}
}


// DATA_fooAORIG_foo ̂Q܂Ƃ߂Ē`}N
#define HOOK_DEFINE(dll, rettype, name, argtype, vars) \
	static HookData  DATA_##name; \
	rettype WINAPI ORIG_##name argtype \
	{ \
		EnterCriticalSection(&DATA_##name.lock); \
		memcpy(DATA_##name.addr, DATA_##name.orig, sizeof(DATA_##name.orig)); \
		FlushInstructionCache((HANDLE)-1, DATA_##name.addr, sizeof(DATA_##name.orig)); \
		rettype v = ( (rettype (WINAPI*) argtype) DATA_##name.addr) vars; \
		memcpy(DATA_##name.addr, DATA_##name.hook, sizeof(DATA_##name.hook)); \
		FlushInstructionCache((HANDLE)-1, DATA_##name.addr, sizeof(DATA_##name.hook)); \
		LeaveCriticalSection(&DATA_##name.lock); \
		return v; \
	}
#include "hooklist.h"
#undef HOOK_DEFINE

//

#define HOOK_DEFINE(dll, rettype, name, argtype, vars) \
	_hook_init((FARPROC)name, &DATA_##name, (FARPROC)IMPL_##name);
static void hook_init() {
#include "hooklist.h"
}
#undef HOOK_DEFINE

//

#define HOOK_DEFINE(dll, rettype, name, argtype, vars) \
	_hook_term(&DATA_##name);
static void hook_term() {
#include "hooklist.h"
}
#undef HOOK_DEFINE

//---

CTlsData<CThreadLocalInfo>	g_TLInfo;
CGdiPPSettings*				g_pSettings;
HINSTANCE					g_hinstDLL;
#ifdef _DEBUG
HANDLE						g_hfDbgText;
#endif

void InstallManagerHook();
void RemoveManagerHook();

//x[XAhXς[hȂ
#pragma comment(linker, "/base:0x06540000")
BOOL WINAPI  DllMain(HINSTANCE instance, DWORD reason, LPVOID lp)
{
	switch(reason) {
	case DLL_PROCESS_ATTACH:
		//
		//DLL_PROCESS_DETACHł͂̋tɂ
		//1. CRT֐̏
		//2. NeBJZNV̏
		//3. TLS̏
		//4. g_pSettings̃CX^XAINIǂݍ
		//5. ExcludeModule`FbN
		// 6. FreeTypeCȕ
		// 7. FreeTypeFontEnginẽCX^X
		// 8. APItbN
		// 9. ManagerGetProcAddresstbN

		//1
		_CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_LEAK_CHECK_DF);
		_CrtSetReportMode(_CRT_ASSERT, _CRTDBG_MODE_DEBUG | _CRTDBG_MODE_WNDW);
		//_CrtSetBreakAlloc(100);

		//Opera~܂`
		//Assert(GetModuleHandleA("opera.exe") == NULL);

		setlocale(LC_ALL, "");
		g_hinstDLL = instance;

		//2, 3
		CCriticalSectionLock::Init();
		if (!g_TLInfo.ProcessInit()) {
			return FALSE;
		}

		//4
		g_pSettings = new CGdiPPSettings;
		if (!g_pSettings || !g_pSettings->LoadSettings(instance)) {
			return FALSE;
		}
//		if (IsProcessExcluded()) {
//			return FALSE;
//		}

		//5
		if (!IsProcessExcluded()) {
			//6 ` 9
			// FreeType
			if (!FontLInit()) {
				return FALSE;
			}
			g_pFTEngine = new FreeTypeFontEngine;
			if (!g_pFTEngine) {
				return FALSE;
			}

			hook_init();
			InstallManagerHook();
		}
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		g_TLInfo.ThreadTerm();
		break;
	case DLL_PROCESS_DETACH:
		RemoveManagerHook();
		hook_term();

		if (g_pFTEngine) {
			delete g_pFTEngine;
		}
		FontLFree();

		if (g_pSettings) {
			delete g_pSettings;
		}
		g_TLInfo.ProcessTerm();
		CCriticalSectionLock::Term();
		break;
	}
	return TRUE;
}
//EOF
